# Main


bossbar set minecraft:main players @a
difficulty normal
team join players @a[team=!players,scores={death=0}]
team join dead @a[team=!dead,scores={death=2}]
execute store result score players gameData run list
execute if score playerReqMessage gameData matches 0 if score phase gameData matches 2..7 run schedule function other:send_player_message 30t
execute if score playerReqMessage gameData matches 0 if score phase gameData matches 2..7 run scoreboard players set playerReqMessage gameData 1
execute if score players gameData matches 2.. run scoreboard players set playerReqMessage gameData 0

# Join
execute as @a[tag=!joinedBefore] run function main:join
execute as @a[scores={onJoin=1..}] run function main:join

# NoDrop:1b
execute as @e[type=item,nbt={Item:{tag:{NoDrop:1b}}}] at @s run tp @s @p
execute as @e[type=item,nbt={Item:{tag:{NoDrop:1b}}}] run data merge entity @s {PickupDelay:0}

# Reset
tag @a[limit=1] add reset

# 1 = Wait, 2 = Load, 3 = Choose Game, 4 = In-Game, 5 = Game End, 6 = Reset, 7 = Bonus Round, 8 = Winner, 9 = Reset
execute if score phase gameData matches 1 run function main:phase1
execute if score phase gameData matches 2 run function main:phase2
execute if score phase gameData matches 3 run function main:phase3
execute if score phase gameData matches 4 run function main:phase4
execute if score phase gameData matches 5 run function main:phase5
execute if score phase gameData matches 6 run function main:phase6
execute if score phase gameData matches 7 run function main:phase7
execute if score phase gameData matches 8 run function main:phase8
execute if score phase gameData matches 9 run function main:phase9

# Reset
execute if score playing gameData matches 1 if entity @a[scores={reset=1}] unless entity @a[tag=!reset] run scoreboard players set phase gameData 9
execute if score playing gameData matches 1 if entity @a[scores={reset=1}] unless entity @a[tag=!reset] run playsound entity.dragon.growl voice @a ~ ~ ~ 999999 2
execute if score playing gameData matches 1 as @a[scores={reset=1}] unless entity @a[tag=!reset] run tellraw @a [{"text":"- ","color":"white","bold":true},{"text":"The game has been reset!","color":"yellow","bold":false}]
execute as @a[scores={reset=1}] if entity @a[tag=!reset] run tellraw @s [{"text":"- ","color":"white","bold":true},{"text":"Uhm, you're not alone anymore. I'm not going to reset the map for you now!","color":"yellow"}]
execute as @a[scores={reset=1}] if entity @a[tag=!reset] at @s run playsound block.anvil.land voice @s

scoreboard players reset @a reset
scoreboard players enable @a reset
tag @a[tag=reset] remove reset

# Floor
execute if score floor gameData matches 1.. run function other:floor/load
execute unless score phase gameData matches 4..7 run function other:floor/rainbow
scoreboard players add floor const 1
execute if score floor const matches 5 run scoreboard players set floor const 2

# Parkour
function other:parkour

# Inv GUI
execute if score phase gameData matches 1..3 as @a run function other:inventories/main
kill @e[type=item,nbt={Item:{tag:{inv.item:1b}}}]

# Walls
execute if score walls gameData matches 1 if score walls gameData matches 0..31 run function other:wall/enable
execute if score walls gameData matches 0 run function other:wall/disable

# Item Frames
execute as @e[type=item_frame,nbt=!{ItemRotation:0b}] run data modify entity @s ItemRotation set value 0b

# Jumping Off
effect clear @a slow_falling
execute as @a[gamemode=!creative,gamemode=!spectator] at @s if entity @s[y=40,dx=10] run effect give @s slow_falling 1 0 true
execute as @a[gamemode=!creative] at @s if entity @s[y=40,dx=10] run tp @s 0 66 0
execute as @a[gamemode=!creative] at @s store success score @s aboveVoid if block ~ ~ ~ #minecraft:all
execute as @a[gamemode=!creative] if score @s aboveVoid matches 0 if score phase gameData matches 4 run function other:fake_death
execute as @a[gamemode=!creative] if score @s aboveVoid matches 0 run tp @s 0 66 0

# Random
scoreboard players add pointsReward const 1
execute if score pointsReward const matches 31 run scoreboard players set pointsReward const 10
scoreboard players add endSentence const 1
execute if score endSentence const matches 6 run scoreboard players set endSentence const 1

# Effects
execute unless score phase gameData matches 0 unless score phase gameData matches 4 unless score phase gameData matches 7 run effect give @a resistance 999999 255 true
execute unless score phase gameData matches 0 unless score phase gameData matches 4 unless score phase gameData matches 7 run effect give @a[gamemode=!creative] weakness 999999 255 true
execute if score phase gameData matches 4 unless score game gameData matches 4..5 unless score game gameData matches 7 unless score game gameData matches 9 run effect give @a resistance 999999 255 true
effect give @a[scores={food=..19}] saturation 1 0 true
execute as @e[type=falling_block] run data modify entity @s Time set value 1b

# Other
data modify block -23 67 -6 Items set value []
execute if score phase gameData matches 1..3 run clear @a[tag=creator,nbt=!{Inventory:[{id:"minecraft:elytra",Slot:102b}]}] elytra
execute if score phase gameData matches 1..3 run replaceitem entity @a[tag=creator,nbt=!{Inventory:[{id:"minecraft:elytra",Slot:102b}]}] armor.chest elytra{Unbreakable:1b,display:{Name:'{"text":"Elytra","italic":false,"color":"aqua"}'},HideFlags:63,inv.item:1b}
execute if score phase gameData matches 4..5 as @e[type=item,nbt=!{Item:{tag:{GameItem:1b}}}] run data modify entity @s Item.tag.GameItem set value 1b
execute unless score phase gameData matches 4..5 run clear @a #other:all{GameItem:1b}


# CHANGES
# Made breaking snow in Meltdown now remove 2 or 3 layers instead of one depending on the amount of players
# Changed the game time in Snowy Business from 3:00 to 1:30
# Lowered the goal in Present Hunt:
# - 2 players: 7 presents
# - 3-7 players: 5 presents
# - 8+ players: 3 presents
# Changed time until deathmatch in Santa's Standoff from 3:00 to 1:30
# Changed the amount of ice given in Icy Archers from 64 to 20
# Changed the game time in Meat Lovers from 3:00 to 1:30
# Added a deathmatch to Final Showdown after 1:30
# Slightly changed the terrain:
# - Certain areas look smoother
# - It's easier to manouvre through certain areas
# - Can no longer get stuck in certain spots
# Instead of killing the snowman it now gets teleported in the void in Snowy Business
# Improved the inventory GUI performance by a lot
# Moved the fire randomizer for Vortex:
# - Huge FPS Boost (Fire and particles no longer being rendered)
# - Can no longer be seen while in spectator
# The sign that marks the Parkour start has had some changes:
# - Changed the text
# - Now disappears when a minigame is being played
# Added more players to the Testers credit page
# Fixed players being able to cook meat on campfire
# Fixed spectral arrows and tridents not getting killed after Santa's Standoff ends
# Fixed xp bar not getting reset properly after Santa's Standoff ends
# Fixed firework not summoning when a minigame is won
# Fixed players being able to see the placeholder's name when placing Ice in Icy Archers
# Fixed being able to die in the void while lagging
# Fixed being able to escape in Icy Archers
# Fixed the game not always properly modifying your score upon joining while a game is already in progress
